//+------------------------------------------------------------------+
//|                                   Robby DSS Bressert Colored.mq4 |
//|                                                   Jaanus Jantson |
//|                          http://fx.jantson.ee; jaanus@jantson.ee |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "  Tankk,  1  july  2016,  http://forexsystems.ru/" 
#property link      "http://forexsystemsru.com/indikatory-foreks-f41/" 

#property description "     ." 
//#property version   "1.00"

#property indicator_separate_window
#property indicator_buffers 3

#property indicator_color1 Black
#property indicator_color2 LightCyan   //Lime
#property indicator_color3 Red
#property indicator_width1 0
#property indicator_width2 1
#property indicator_width3 1

#property indicator_level1 20
#property indicator_level2 80
//#property indicator_level3 50
#property indicator_levelcolor DarkSlateBlue   //DarkSlateGray // SteelBlue //C'60,61,62' // 
#property indicator_levelstyle STYLE_DOT

#property indicator_minimum 0
#property indicator_maximum 100

//+++======================================================================+++
//+++                 Custom indicator input parameters                    +++
//+++======================================================================+++

extern int     EMAPeriod  =  12;
extern int   StochPeriod  =  14;
extern bool   ShowArrows  =  true;
extern int      Distance  =  3;
extern color     ArrowUP  =  LightCyan,   //Lavender,    //FireBrick,       //Red,
                 ArrowDN  =  Red;        //Magenta;     //DarkGreen;       //Lime
extern int     ArrowSize  =  1,   
                  CodeUP  =  233,   //225
                  CodeDN  =  234;   //226
                  
//+++======================================================================+++
//+++                     Custom indicator buffers                         +++
//+++======================================================================+++
double DssBuffer[];
double DssBuffer_UP[];
double DssBuffer_DW[];
double MitBuffer[];
double smooth_coefficient;
//+++======================================================================+++
//+++              Custom indicator initialization function                +++
//+++======================================================================+++

int init()
{
   IndicatorBuffers(4);
   
   SetIndexBuffer(0,DssBuffer);
   SetIndexBuffer(1,DssBuffer_UP);
   SetIndexBuffer(2,DssBuffer_DW);
   SetIndexBuffer(3,MitBuffer);
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_ARROW);   SetIndexArrow(1,217);   //159
   SetIndexStyle(2,DRAW_ARROW);   SetIndexArrow(2,218);
   
   SetIndexLabel(0, "DSS Line");
   SetIndexLabel(1, "DSS UP");
   SetIndexLabel(2, "DSS DW");
   
   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(2, 0.0);

   IndicatorShortName ("DSS Arrows ["+EMAPeriod+","+StochPeriod+"]");

   smooth_coefficient = 2.0 / (1.0 + EMAPeriod);
   
//----
   return(0);
}
//+++======================================================================+++
//+++              Custom indicator deinitialization function              +++
//+++======================================================================+++
int deinit() 
{
   ARROWS_DELETE();
   return(0);
}
//+++======================================================================+++
void ARROWS_DELETE() 
{
   string name;   string pref="DSS ["+EMAPeriod+","+StochPeriod+"] _ ";
   for (int a=ObjectsTotal()-1; a>=0; a--) 
     {
      name=ObjectName(a);
      if (StringSubstr(name,0,StringLen(pref))==pref) ObjectDelete(name);
     }
}
//+++======================================================================+++
//+++                 Custom indicator iteration function                  +++
//+++======================================================================+++

int start()
{
   int i, limit, counted_bars=IndicatorCounted(), Bar_OK;
   if (counted_bars == 0)   limit = Bars - StochPeriod;
   if (counted_bars > 0)   limit = Bars - counted_bars;
//+++======================================================================+++
   double HighRange, LowRange;
   double delta, MIT;
   
   for (i = limit; i >= 0; i--)
     {
      HighRange = High[iHighest(NULL,0,MODE_HIGH,StochPeriod,i)];
      LowRange = Low[iLowest(NULL,0,MODE_LOW,StochPeriod,i)];
      delta = Close[i] - LowRange;
      MIT = delta/(HighRange - LowRange)*100.0;
      MitBuffer[i] = smooth_coefficient * (MIT - MitBuffer[i+1]) + MitBuffer[i+1];
     }
//+++======================================================================+++
   double DSS;
   
   for (i = limit; i >= 0; i--)
     {
      HighRange = MitBuffer[ArrayMaximum(MitBuffer, StochPeriod, i)];
      LowRange = MitBuffer[ArrayMinimum(MitBuffer, StochPeriod, i)];
      
      delta = MitBuffer[i] - LowRange;
      DSS = delta/(HighRange - LowRange)*100.0;
      DssBuffer[i] = smooth_coefficient * (DSS - DssBuffer[i+1]) + DssBuffer[i+1];
     }
//+++======================================================================+++
   for (i = limit; i >= 0; i--)
     {
      //DssBuffer_UP[i]=EMPTY_VALUE;
      //DssBuffer_DW[i]=EMPTY_VALUE;
      Bar_OK=0;
      
      if (DssBuffer[i] > DssBuffer[i+1])
       {
        DssBuffer_UP[i]=DssBuffer[i];
        Bar_OK=1;
        DssBuffer_DW[i] = 0.0;
       }

      if (DssBuffer[i] < DssBuffer[i+1])
       {
        DssBuffer_DW[i]=DssBuffer[i];
        Bar_OK=1;
        DssBuffer_UP[i] = 0.0;
       }

      if (Bar_OK==0)
       {
        DssBuffer_UP[i]=DssBuffer_UP[i+1];
        DssBuffer_DW[i]=DssBuffer_DW[i+1];
       }   
       
      if (ShowArrows)
       {
        if (DssBuffer[i] < DssBuffer[i+1] && DssBuffer[i+1] > DssBuffer[i+2])   manageArr(i,"ArrowDW",ArrowDN,CodeDN,ArrowSize,true );   // !
        if (DssBuffer[i] > DssBuffer[i+1] && DssBuffer[i+1] < DssBuffer[i+2])   manageArr(i,"ArrowUP",ArrowUP,CodeUP,ArrowSize,false);   // !
        //if (DssBuffer_DW[i+1]!=0.0 && DssBuffer_DW[i+2]==0.0)   manageArr(i,"ArrowDW",ArrowDN,CodeDN,ArrowSize,true );   //!
        //if (DssBuffer_UP[i+1]!=0.0 && DssBuffer_UP[i+2]==0.0)   manageArr(i,"ArrowUP",ArrowUP,CodeUP,ArrowSize,false);   //!
       }
      
   }
//----
   return(0);
}
//+++======================================================================+++
//+++======================================================================+++

void manageArr(int z, string text, color Clr, int Code, int Size, bool DN)   
{
   string objName = "DSS ["+EMAPeriod+","+StochPeriod+"] _ "+text+" _ "+Time[z]+" = "+Close[z];
   //double Gap = 2.0*iATR(NULL,0,20,z)/4.0;
   double Gap=Distance*Point;   if (Digits==3 || Digits==5) Gap=Distance*10*Point;
   
   ObjectCreate(objName, OBJ_ARROW,0,Time[z],0);
   ObjectSet   (objName, OBJPROP_TEXT, text);  
   ObjectSet   (objName, OBJPROP_COLOR, Clr);  
   ObjectSet   (objName, OBJPROP_ARROWCODE,Code);
   ObjectSet   (objName, OBJPROP_WIDTH,Size);  
   
   if (DN)
      ObjectSet(objName,OBJPROP_PRICE1,High[z]+Gap*1.3);   
      
     else  
      ObjectSet(objName,OBJPROP_PRICE1,Low[z] -Gap);
}
//+++======================================================================+++
//+++======================================================================+++
//+++======================================================================+++